using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Mythos._0_Modelos;
using System.Transactions;
using System.Data.SqlClient;
using System.Threading;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Mythos._1_Datos
{
    public class MYT_EstructurasPartesPeticionDatos_Preguntas_Datos : ABS_Datos
    {

        #region Listado
        
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }

        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }

        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {}
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }

        #endregion
        #region F3

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }

        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }

        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
        }
        #endregion

        #region Obtener
        public override dynamic Obtener(long _lng_id)
        {
            return null;
        }

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo g_mdl_INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo_PARALISTADO = null;
        public INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                 //WHERE
                                 " WHERE " +
                                 nameof(MYT_EstructurasPartesPeticionDatos_Preguntas) + "." + nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.fechaBorrado) + "  is null AND " + 
                                 nameof(MYT_EstructurasPartesPeticionDatos_Preguntas) + "." + nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_EstructurasPartesPeticionDatos_Preguntas_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo_PARALISTADO;
        }

        #region Ejecutar Consulta Modelo Para Listado
        private static int g_int_TotalHilos_Modelo_PARALISTADO = 1;
        private bool[] g_bol_Hilos_Terminados_Modelo_PARALISTADO = new bool[g_int_TotalHilos_Modelo_PARALISTADO];
        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                             object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo_PARALISTADO = obj_Exferia_Entities.Database.SqlQuery<INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo>(_str_SQL, _arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_mdl_INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo_PARALISTADO != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_PARALISTADO; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Modelo_PARALISTADO[int_Contador] = false;
                    }

                    //MYT_EstructurasPartesPeticionDatos_Repuestas ##########################################################################################
                    ThreadStart obj_ThreadStart_RESPUESTAS = new ThreadStart(Obtener_ProtocolosRespuestas_Modelo_ParaListado);
                    Thread obj_Thread_RESPUESTAS = new Thread(obj_ThreadStart_RESPUESTAS);
                    obj_Thread_RESPUESTAS.Start();

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_PARALISTADO)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_EstructurasPartesPeticionDatos_Preguntas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #region Tablas Relacionadas
        private void Obtener_ProtocolosRespuestas_Modelo_ParaListado()
        {
            try
            {
                MYT_EstructurasPartesPeticionDatos_Repuestas_Datos obj_MYT_EstructurasPartesPeticionDatos_Repuestas_Datos = new MYT_EstructurasPartesPeticionDatos_Repuestas_Datos();
                g_mdl_INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo_PARALISTADO.MYT_EstructurasPartesPeticionDatos_Repuestas = obj_MYT_EstructurasPartesPeticionDatos_Repuestas_Datos.Obtener_ModeloListado_Por_IdEstructuraPartePeticionDatoPregunta(g_mdl_INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo_PARALISTADO.id);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_PARALISTADO[0] = true;
            }
        }
        #endregion
        #endregion
        #endregion

        #region Listado
        private List<INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo> g_lst_INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo_PARALISTADO = null;

        public List<INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo> Obtener_ModeloListado_Por_IdEstructuraPartePeticionDatoSeccion(List<long> _lst_idEstructuraPartePeticionDatoSeccion,
                                                                                                                                 bool _bol_Cargar_EstructuraPartePeticionDatosRespuestas)
        {
            try
            {
                g_lst_MYT_EstructurasPartesPeticionDatos_Repuestas = null;

                if (_lst_idEstructuraPartePeticionDatoSeccion != null && _lst_idEstructuraPartePeticionDatoSeccion.Count > 0)
                {
                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(MYT_EstructurasPartesPeticionDatos_Preguntas),
                                                                                             nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.idEstructuraPartePeticionDatoSeccion),
                                                                                             G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                             _lst_idEstructuraPartePeticionDatoSeccion);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                                " WHERE " +
                                                    nameof(MYT_EstructurasPartesPeticionDatos_Preguntas) + "." + nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.fechaBorrado) + " is null and " +
                                                    str_Filtro_IDS;


                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { },
                                                    _bol_Cargar_EstructuraPartePeticionDatosRespuestas);


                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_EstructurasPartesPeticionDatos_Repuestas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdEstructuraPartePeticionDatoSeccion), true);
            }

            return g_lst_INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo_PARALISTADO;
        }

        #region Ejecutar Consulta
        //Listado de modelos Relacionados
        private List<MYT_EstructurasPartesPeticionDatos_Repuestas> g_lst_MYT_EstructurasPartesPeticionDatos_Repuestas = null;

        //Hilos
        private static int g_int_TotalHilos_Modelo_Listado = 1;
        private bool[] g_bol_Hilos_Terminados_Modelo_Listado = new bool[g_int_TotalHilos_Modelo_Listado];

        private void Ejecutar_Consulta_Modelo_Listado(  string _str_SQL,
                                                        object[] _arr_Parametros,
                                                        bool _bol_Cargar_EstructuraPartePeticionDatosRespuestas)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el modelo
                g_lst_INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo_PARALISTADO = obj_Exferia_Entities.Database.SqlQuery<INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo>(_str_SQL, _arr_Parametros).ToList();

                #region Rellenar tablas Relacionadas
                if (g_lst_INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo_PARALISTADO != null && g_lst_INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo_PARALISTADO.Count > 0)
                {
                    //Si tiene que buscar alguna tabla relacionada
                    if (_bol_Cargar_EstructuraPartePeticionDatosRespuestas)
                    {
                        #region PRIMERO BUSCO LOS DATOS DE LAS TABLAS RELACIONADAS
                        //reiniciar Valores de los hilos
                        for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_Listado; int_Contador++)
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[int_Contador] = false;
                        }

                        //MYT_EstructurasPartesPeticionDatos_Repuestas #############################################
                        if (_bol_Cargar_EstructuraPartePeticionDatosRespuestas)
                        {
                            ThreadStart obj_ThreadStart_ESTRUCTURAPETICIONDATOSRESPUESTAS = new ThreadStart(Obtener_EstructuraPeticionDatosRespuestas_Modelo_Listado);
                            Thread obj_Thread_ESTRUCTURAPETICIONDATOSRESPUESTAS = new Thread(obj_ThreadStart_ESTRUCTURAPETICIONDATOSRESPUESTAS);
                            obj_Thread_ESTRUCTURAPETICIONDATOSRESPUESTAS.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
                        }

                        //Esperando a que terminen todos los hilos .........................................
                        bool bol_Termino = false;
                        while (bol_Termino == false)
                        {
                            bol_Termino = true;
                            foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_Listado)
                            {
                                if (bol_Termino_Hilo == false)
                                {
                                    bol_Termino = false;
                                    break;
                                }
                            }

                            Thread.Sleep(10);
                        }
                        //.................................................................................

                        #endregion

                        #region DESPUES SE LO VOY ASIGNANDO A LOS REGISTRO UNO A UNO
                        foreach (INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo mdl_INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo in g_lst_INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo_PARALISTADO)
                        {
                            //MYT_EstructurasPartesPeticionDatos_Repuestas #############################################
                            if (_bol_Cargar_EstructuraPartePeticionDatosRespuestas &&
                                g_lst_MYT_EstructurasPartesPeticionDatos_Repuestas != null &&
                                g_lst_MYT_EstructurasPartesPeticionDatos_Repuestas.Count > 0)
                            {
                                mdl_INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo.MYT_EstructurasPartesPeticionDatos_Repuestas = g_lst_MYT_EstructurasPartesPeticionDatos_Repuestas.Where(m => m.idEstructuraPartePeticionDatoPregunta == mdl_INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo.id).ToList();
                            }
                        }
                        #endregion

                    }
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_EstructurasPartesPeticionDatos_Preguntas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #region TablasRelacionadas
        private void Obtener_EstructuraPeticionDatosRespuestas_Modelo_Listado()
        {
            try
            {
                MYT_EstructurasPartesPeticionDatos_Repuestas_Datos obj_MYT_EstructurasPartesPeticionDatos_Repuestas_Datos = new MYT_EstructurasPartesPeticionDatos_Repuestas_Datos();
                g_lst_MYT_EstructurasPartesPeticionDatos_Repuestas = obj_MYT_EstructurasPartesPeticionDatos_Repuestas_Datos.Obtener_ModeloListado_Por_IdsEstructuraPartePeticionDatoPregunta(g_lst_INTERNO_MYT_EstructurasPartesPeticionDatos_Preguntas_Listado_Modelo_PARALISTADO.Select(x => x.id).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
            }
        }
        #endregion

        #endregion
        #endregion


        private string Obtener_Consulta_Modelo()
        {
            return
               " SELECT " +
                   nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.id) + " , " +
                   nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.descripcion) + " , " +
                   nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.idEstructuraPartePeticionDatoSeccion) + " , " +
                   nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.tipo) + " , " +
                   nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.fechaBorrado) +
               " FROM " + nameof(MYT_EstructurasPartesPeticionDatos_Preguntas);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                MYT_EstructurasPartesPeticionDatos_Preguntas mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_AGrabar = (MYT_EstructurasPartesPeticionDatos_Preguntas)_mdl_obj;
                MYT_EstructurasPartesPeticionDatos_Preguntas mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_DatosViejos = new MYT_EstructurasPartesPeticionDatos_Preguntas();

                // Ver si existe ###################################################################### 
                MYT_EstructurasPartesPeticionDatos_Preguntas mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_Final = Obtener_Modelo_Por_Id(mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_Final, mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_AGrabar, mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_Final, false, false);

                    #region update
                    string str_SQL_Update = " UPDATE " + nameof(MYT_EstructurasPartesPeticionDatos_Preguntas) +
                                           " SET " +
                                               nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.descripcion) + "=@descripcion," +
                                               nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.idEstructuraPartePeticionDatoSeccion) + "=@idEstructuraPartePeticionDatoSeccion," +
                                               nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.tipo) + "=@tipo," +
                                               nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.fechaBorrado) + "=@fechaBorrado " +
                                           " WHERE " +
                                               nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@descripcion",  mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_AGrabar.descripcion),
                        new SqlParameter("@idEstructuraPartePeticionDatoSeccion",  mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_AGrabar.idEstructuraPartePeticionDatoSeccion),
                        new SqlParameter("@tipo",  mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_AGrabar.tipo),
                         mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id",  mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_AGrabar.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_AGrabar.id;
                }
                //INSERT
                else
                {
                    mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_Final = new MYT_EstructurasPartesPeticionDatos_Preguntas();

                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_AGrabar, mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(MYT_EstructurasPartesPeticionDatos_Preguntas) +
                                               " (" +
                                                       nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.descripcion) + "," +
                                                       nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.idEstructuraPartePeticionDatoSeccion) + "," +
                                                       nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.tipo) + "," +
                                                       nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.fechaBorrado) +
                                               " ) " +
                                               " OUTPUT INSERTED." + nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.id) +
                                               " VALUES " +
                                               " ( " +
                                                   "@descripcion," +
                                                   "@idEstructuraPartePeticionDatoSeccion," +
                                                   "@tipo," +
                                                   "@fechaBorrado" +
                                               " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@descripcion",  mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_AGrabar.descripcion),
                        new SqlParameter("@idEstructuraPartePeticionDatoSeccion",  mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_AGrabar.idEstructuraPartePeticionDatoSeccion),
                        new SqlParameter("@tipo",  mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_AGrabar.tipo),
                         mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),

                    };
                    #endregion

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(MYT_EstructurasPartesPeticionDatos_Preguntas), mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_DatosViejos, mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_Final, mdl_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_EstructurasPartesPeticionDatos_Preguntas_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                MYT_EstructurasPartesPeticionDatos_Preguntas mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_Final != null)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(MYT_EstructurasPartesPeticionDatos_Preguntas) +
                                              " SET " +
                                              nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.fechaBorrado) + "=@fechaBorrado " +
                                          " WHERE " +
                                              nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(MYT_EstructurasPartesPeticionDatos_Preguntas), null, mdl_MYT_EstructurasPartesPeticionDatos_Preguntas_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                //Devolver tambien el Objeto
                mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_EstructurasPartesPeticionDatos_Preguntas_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }

        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            throw new NotImplementedException();
        }

        public INTERNO_ValorDevuelto_Modelo Borrar_Por_IdEstructuraPartePeticionDatoSeccion(long _lng_idEstructuraPartePeticionDatoSeccion)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                #region Update
                string str_SQL_Update = " UPDATE " + nameof(MYT_EstructurasPartesPeticionDatos_Preguntas) +
                                            " SET " +
                                            nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.fechaBorrado) + "=@fechaBorrado " +
                                        " WHERE " +
                                            nameof(MYT_EstructurasPartesPeticionDatos_Preguntas.idEstructuraPartePeticionDatoSeccion) + "=@idEstructuraPartePeticionDatoSeccion";

                //Parametros
                object[] arr_Parametros_Update = new object[]
                {
                    new SqlParameter("@fechaBorrado",  DateTime.Now),
                    new SqlParameter("@idEstructuraPartePeticionDatoSeccion", _lng_idEstructuraPartePeticionDatoSeccion)
                };
                #endregion

                //Update
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_EstructurasPartesPeticionDatos_Preguntas_Datos) + "/" + nameof(Borrar_Por_IdEstructuraPartePeticionDatoSeccion), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
